var map, startPointLayer, endPointLayer, lineLayer, control, gpxLayer;

var baseURL = "http://localhost:8888/websites/pgrouting_full";



$(document).ready(function() {
    map = new OpenLayers.Map({
        div: "map",
        projection: new OpenLayers.Projection("EPSG:900913"),
        units: 'm'
    });

    // Background layer
    var osm = new OpenLayers.Layer.OSM();
    map.addLayer(osm);

    // Will be used to display the bounding box
    var bbLayer = new OpenLayers.Layer.Vector("Bounding Box", {
        styleMap: new OpenLayers.Style({
            fillColor: "transparent",
            strokeColor: "#FF0000",
            strokeWidth: "5"
        })
    });
    var wkt = new OpenLayers.Format.WKT();
    var features = wkt.read('POLYGON((735510.1394669333 5868379.131261879, 741309.8849364555 5868379.131261879, 741309.8849364555 5861502.898918662, 735510.1394669333 5861502.898918662, 735510.1394669333 5868379.131261879))');
    bbLayer.addFeatures(features);
    map.addLayer(bbLayer);


    var myStyles = new OpenLayers.StyleMap({
        "default": new OpenLayers.Style({
            externalGraphic: "${getIcon}",
            strokeColor: "#FF0000",
            graphicHeight: 40,
            graphicYOffset: -43
        }, {
            context: {
                getIcon: function(feature) {
                    // ???
                    // Depends on types attributes
                    // return assets/img/dot_1.png for 'start'
                    // return assets/img/dot_2.png for 'end'

                }
            }
        })
    });

    startPointLayer = new OpenLayers.Layer.Vector("Start Point Layer", {
        styleMap: myStyles
    });
    endPointLayer = new OpenLayers.Layer.Vector("Endp Point Layer", {
        styleMap: myStyles
    });


    lineLayer = new OpenLayers.Layer.Vector("Roads", {
        protocol: new OpenLayers.Protocol.HTTP({
            url: baseURL + "/routing.php",
            format: new OpenLayers.Format.GeoJSON()
        }),
        projection: new OpenLayers.Projection("EPSG:900913"),
        strategies: [new OpenLayers.Strategy.Fixed()],
        styleMap: new OpenLayers.StyleMap({
            "default": new OpenLayers.Style({
                strokeWidth: "5"
            })
        })
    });


    map.addLayers([startPointLayer, endPointLayer, lineLayer]);

    // Center map
    map.zoomToExtent(new OpenLayers.Bounds(733555.2999229, 5862431.2752237, 743339.23954204, 5867208.5894909))

    // Enable draw control
    control = new OpenLayers.Control.DrawFeature(startPointLayer, OpenLayers.Handler.Point);
    map.addControl(control);
    control.activate();

    startPointLayer.events.register('beforefeatureadded', control, function(e) {
        // ???
        // Clean the layer and the line layer
        // Set type attribute to 'start' on e.feature
        // Call correct_point

    });
    endPointLayer.events.register('beforefeatureadded', control, function(e) {
        // ???
        // Clean the layer and the line layer
        // Set type attribute to 'end' on e.feature
        // Call correct_point
    });

    function correct_point(event) {

        $.ajax({

            url: 'point_to_id.php',
            data: {
                "lon": event.feature.geometry.x,
                "lat": event.feature.geometry.y,
                "srid": 900913
            },
            success: function(data, textStatus, jqXHR) {
                if (data.success) {
                    // ???
                    // Move the feature to the correct lonlat
                    // Add a feature attribute with the received id
                } else {
                    // ???
                    // Clean layer and alert the error
                }
            },
            error: function(data) {
                event.object.removeAllFeatures();
                alert('Meh... Something went wrong...');
            }
        });

    };

    $(document).on('click', '#point_selector .btn', function() {


        // ???
        // depends on the clicked button
        // set draw control to the active layer
        // Toggling active class on button


    });





    $(document).on('click', '#search', function() {
        if (startPointLayer.features.length == 1) {
            if (endPointLayer.features.length == 1) {
                if (startPointLayer.features[0].attributes.id && endPointLayer.features[0].attributes.id) {

                    lineLayer.protocol.options.url = baseURL +
                        "/routing.php?" +
                        "start=" + startPointLayer.features[0].attributes.id +
                        "&end=" + endPointLayer.features[0].attributes.id +
                        "&srid=900913";
                    lineLayer.refresh();

                } else {
                    alert("A point has not been encoded...");
                }
            } else {
                alert("You have to define a destination");
            }
        } else {
            alert("You have to define a start");
        }
    });

    $(document).on('click', '#invert', function() {

        var start = startPointLayer.features;
        var end = endPointLayer.features;

        startPointLayer.removeAllFeatures();
        endPointLayer.removeAllFeatures();

        endPointLayer.addFeatures(start);
        startPointLayer.addFeatures(end);

        $('#search').trigger('click');

    });
});